searchNodes=[{"doc":"Bring the power of in memory storage with ETS and Mnesia to your Elixir application. ActiveMemory provides a simple interface and configuration which abstracts the ETS and Mnesia specifics and provides a common interface called a Store . Example setup Define a Table with attributes. Define a Store with configuration settings or accept the defaults (most applications should be fine with defaults). Add the Store to your application supervision tree. Your app is ready! Example Table: defmodule Test.Support.People.Person do use ActiveMemory.Table , options : [ index : [ :last , :cylon? ] ] attributes do field :email field :first field :last field :hair_color field :age field :cylon? end end Example Mnesia Store (default): defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person end Example ETS Store: defmodule MyApp.People.Store do use ActiveMemory.Store , type : :ets end Add the Store to your application supervision tree: defmodule MyApp.Application do # code.. def start ( _type , _args ) do children = [ # other children MyApp.People.Store , # other children ] # code.. end","ref":"ActiveMemory.html","title":"ActiveMemory","type":"module"},{"doc":"Migrations will get run on app startup and are designed to modify :mnesia's schema. Table Copies In the options of an ActiveMemory.Table, the copy type and nodes which should have them can be specified. Ram copies Tables that only reside in ram on the nodes specified. The default is node() Example table using default setting: defmodule Test.Support.Dogs.Dog do use ActiveMemory.Table , options : [ compressed : true , read_concurrency : true ] . # module code . end The default will be [node()] and this table will reside on the node() ram. Example table spcifing nodes and ram copies: defmodule Test.Support.Dogs.Dog do use ActiveMemory.Table , options : [ compressed : true , read_concurrency : true , ram_copes : [ node ( ) | Node . list ( ) ] . # module code . end All the active nodes in Node.list() and node() will have ram copes of the table. Disc copies Disc copy tables reside both in ram and disc on the nodes specified. In order to persist to disc the schema must be setup on at lest one running node. The default is [] (no nodes). Example table spcifing nodes and disc copies: defmodule Test.Support.Dogs.Dog do use ActiveMemory.Table , options : [ compressed : true , read_concurrency : true , disc_copes : [ node ( ) ] . # module code . end The table will have a ram copy and disc copy on node() Disc only copies Disc oly tables reside only on disc on the nodes specified. In order to persist to disc the schema must be setup on at lest one running node. The default is [] (no nodes). Example table spcifing nodes and disc copies: defmodule Test.Support.Dogs.Dog do use ActiveMemory.Table , options : [ compressed : true , read_concurrency : true , disc_only_copes : [ node ( ) ] . # module code . end The table will only have a disc copy on node() Table Read and Write Access Mnesia tables can be set to read_only or read_write . The default is read_write . Read only tables updates cannot be performed. if you need to change the access use the following syntax: [access_mode: :read_only] Table Types Tables can be either a :set , :ordered_set , or a :bag . The default is :set if you need to change the type use the following syntax: [type: :bag] Indexes If Indexes are desired specify an atom attribute list for which Mnesia is to build and maintain an extra index table. The qlc query compiler may be able to optimize queries if there are indexes available. To specify Indexes use the following syntax: [index: [:age, :hair_color, :cylon?]] Table Load Order The load order priority is by default 0 (zero) but can be set to any integer. The tables with the highest load order priority are loaded first at startup. If you need to change the load order use the following syntax: [load_order: 2] Majority If true, any (non-dirty) update to the table is aborted, unless a majority of the table replicas are available for the commit. When used on a fragmented table, all fragments are given the same the same majority setting. If you need to modify the majority use the following syntax: [majority: true]","ref":"ActiveMemory.Adapters.Mnesia.Migration.html","title":"ActiveMemory.Adapters.Mnesia.Migration","type":"module"},{"doc":"","ref":"ActiveMemory.Adapters.Mnesia.Migration.html#migrate_table_options/1","title":"ActiveMemory.Adapters.Mnesia.Migration.migrate_table_options/1","type":"function"},{"doc":"The match query syntax Using the match macro you can structure a basic query. query = match ( :department == &quot;sales&quot; or :department == &quot;marketing&quot; and :start_date &gt; last_month ) Store . select ( query )","ref":"ActiveMemory.Query.html","title":"ActiveMemory.Query","type":"module"},{"doc":"","ref":"ActiveMemory.Query.html#match/1","title":"ActiveMemory.Query.match/1","type":"macro"},{"doc":"The Store Store API Store.all/0 Get all records stored Store.delete/1 Delete the record provided Store.delete_all/0 Delete all records stored Store.one/1 Get one record matching either an attributes search or match query Store.select/1 Get all records matching either an attributes search or match query Store.withdraw/1 Get one record matching either an attributes search or match query, delete the record and return it Store.write/1 Write a record into the memmory table Seeding When starting a Store there is an option to provide a valid seed file and have the Store auto load seeds contained in the file. defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , seed_file : Path . expand ( &quot;person_seeds.exs&quot; , __DIR__ ) end Before init All stores are GenServers and have init functions. While those are abstracted you can still specify methods to run during the init phase of the GenServer startup. Use the before_init keyword and add the methods as tuples with the arguments. defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , before_init : [ { :run_me , [ &quot;arg1&quot; , &quot;arg2&quot; , ... ] } , { :run_me_too , [ ] } ] end Initial State All stores are GenServers and thus have a state. The default state is an array as such: %{ started_at : &quot;date time when first started&quot; , table : MyApp.People.Store } This default state can be overwritten with a new state structure or values by supplying a method and arguments as a tuple to the keyword initial_state . defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , initial_state : { :initial_state_method , [ &quot;arg1&quot; , &quot;arg2&quot; , ... ] } end","ref":"ActiveMemory.Store.html","title":"ActiveMemory.Store","type":"module"},{"doc":"Define your table attributes and options. Example Table (without auto generated uuid): defmodule Test.Support.People.Person do use ActiveMemory.Table , options : [ index : [ :last , :cylon? ] ] attributes do field :email field :first field :last field :hair_color field :age field :cylon? end end Auto Generated UUID A table can have an auto generated UUID. Specify the option auto_generate_uuid: true in the attributes as an option. Example Table with auto generated uuid: defmodule Test.Support.People.Person do use ActiveMemory.Table , options : [ index : [ :last , :cylon? ] ] attributes auto_generate_uuid : true do field :email field :first field :last field :hair_color field :age field :cylon? end end Options when creating tables ActiveMemory.Table support almost all of the same options as :ets and :mneisia . Please be aware that the options are different for :ets and :mneisia . Further reading can be found with ETS docs and Mnesia docs . All options should be structured as a Keyword list . Example: use ActiveMemory.Table , type : :ets , options : [ compressed : true , read_concurrency : true , type : :protected ] Mnesia Options Table Read and Write Access Mnesia tables can be set to read_only or read_write . The default is read_write . Read only tables updates cannot be performed. if you need to change the access use the following syntax: [access_mode: :read_only] Table Types Tables can be either a :set , :ordered_set , or a :bag . The default is :set if you need to change the type use the following syntax: [type: :bag] Disk Copies A list of nodes can be specified to maintain disk copies of the table. Nodes specified will recieve a replica of the table. Disk copy talbes still maintain a ram copy of the table as well. By default all tables are ram_copies and no disc_copies are specified. if you need to specify nodes use following syntax: [disc_copies: [node1, node2, node3, ...]] Disk Only Copies A list of nodes can be specified to maintain only disk copies. A disc only table replica is kept on disc only and unlike the other replica types, the contents of the replica do not reside in RAM. These replicas are considerably slower than replicas held in RAM. if you need to specify nodes use following syntax: [disc_only_copies: [node1, node2, node3, ...]] Ram Copies A list of nodes can be specified to maintain ram copies of the table. Nodes specified will recieve a replica of the table. By default all tables are set to ram_copies: [ram_copies: [node()]] if you need to specify nodes use following syntax: [ram_copies: [node1, node2, node3, ...]] Indexes If Indexes are desired specify an atom attribute list for which Mnesia is to build and maintain an extra index table. The qlc query compiler may be able to optimize queries if there are indexes available. To specify Indexes use the following syntax: [index: [:age, :hair_color, :cylon?]] Table Load Order The load order priority is by default 0 (zero) but can be set to any integer. The tables with the highest load order priority are loaded first at startup. If you need to change the load order use the following syntax: [load_order: 2] Majority If true, any (non-dirty) update to the table is aborted, unless a majority of the table replicas are available for the commit. When used on a fragmented table, all fragments are given the same the same majority setting. If you need to modify the majority use the following syntax: [majority: true] ETS Options Table Access Access options are: :public :protected or :private . The default access is :public if you need to change the access use the following syntax: [access: :private] Table Types Tables can be either a :set , :ordered_set , :bag , or a :duplicate_bag . The default is :set if you need to change the type use the following syntax: [type: :bag] Compression Compression can be used to help shrink the size of the memory the data consumes, however this does mean the access is slower. The default is false where no compression happens. if you need to change the compression use the following syntax: [Compression: true] Read Concurrency From ETS documentation: Performance tuning. Defaults to false . When set to true, the table is optimized for concurrent read operations. When this option is enabled read operations become much cheaper; especially on systems with multiple physical processors. However, switching between read and write operations becomes more expensive. You typically want to enable this option when concurrent read operations are much more frequent than write operations, or when concurrent reads and writes comes in large read and write bursts (that is, many reads not interrupted by writes, and many writes not interrupted by reads). You typically do not want to enable this option when the common access pattern is a few read operations interleaved with a few write operations repeatedly. In this case, you would get a performance degradation by enabling this option. Option read_concurrency can be combined with option write_concurrency. You typically want to combine these when large concurrent read bursts and large concurrent write bursts are common. if you need to change the read_concurrency use the following syntax: [read_concurrency: true] Write Concurrency From ETS documentation: Performance tuning. Defaults to false , in which case an operation that mutates (writes to) the table obtains exclusive access, blocking any concurrent access of the same table until finished. If set to true, the table is optimized for concurrent write access. Different objects of the same table can be mutated (and read) by concurrent processes. This is achieved to some degree at the expense of memory consumption and the performance of sequential access and concurrent reading. The auto alternative for the write_concurrency option is similar to the true option but automatically adjusts the synchronization granularity during runtime depending on how the table is used. This is the recommended write_concurrency option when using Erlang/OTP 25 and above as it performs well in most scenarios. The write_concurrency option can be combined with the options read_concurrency and decentralized_counters. You typically want to combine write_concurrency with read_concurrency when large concurrent read bursts and large concurrent write bursts are common; for more information, see option read_concurrency. It is almost always a good idea to combine the write_concurrency option with the decentralized_counters option. Notice that this option does not change any guarantees about atomicity and isolation. Functions that makes such promises over many objects (like insert/2) gain less (or nothing) from this option. The memory consumption inflicted by both write_concurrency and read_concurrency is a constant overhead per table for set, bag and duplicate_bag when the true alternative for the write_concurrency option is not used. For all tables with the auto alternative and ordered_set tables with true alternative the memory overhead depends on the amount of actual detected concurrency during runtime. The memory overhead can be especially large when both write_concurrency and read_concurrency are combined. if you need to change the write_concurrency use the following syntax: [write_concurrency: true] or [write_concurrency: :auto] Decentralized Counters From ETS documentation: Performance tuning. Defaults to true for all tables with the write_concurrency option set to auto. For tables of type ordered_set the option also defaults to true when the write_concurrency option is set to true. The option defaults to false for all other configurations. This option has no effect if the write_concurrency option is set to false. When this option is set to true, the table is optimized for frequent concurrent calls to operations that modify the tables size and/or its memory consumption (e.g., insert/2 and delete/2). The drawback is that calls to info/1 and info/2 with size or memory as the second argument can get much slower when the decentralized_counters option is turned on. When this option is enabled the counters for the table size and memory consumption are distributed over several cache lines and the scheduling threads are mapped to one of those cache lines. The erl option +dcg can be used to control the number of cache lines that the counters are distributed over. if you need to change the decentralized_counters use the following syntax: [decentralized_counters: true]","ref":"ActiveMemory.Table.html","title":"ActiveMemory.Table","type":"module"},{"doc":"","ref":"ActiveMemory.Table.html#attributes/2","title":"ActiveMemory.Table.attributes/2","type":"macro"},{"doc":"","ref":"ActiveMemory.Table.html#field/2","title":"ActiveMemory.Table.field/2","type":"macro"},{"doc":"","ref":"readme.html","title":"ActiveMemory","type":"extras"},{"doc":"Please note! This is still a work in progess and feedback is appreciated","ref":"readme.html#a-simple-orm-for-ets-and-mnesia","title":"ActiveMemory - A Simple ORM for ETS and Mnesia","type":"extras"},{"doc":"A package to help bring the power of in memory storage with ETS and Mnesia to your Elixir application. ActiveMemory provides a simple interface and configuration which abstracts the ETS and Mnesia specifics and provides a common interface called a Store .","ref":"readme.html#overview","title":"ActiveMemory - Overview","type":"extras"},{"doc":"Define a Table with attributes. Define a Store with configuration settings or accept the defaults (most applications should be fine with defaults). Add the Store to your application supervision tree. Your app is ready! Example Table: defmodule MyApp.People.Person do use ActiveMemory.Table , options : [ index : [ :last , :cylon? ] ] attributes do field ( :email ) field ( :first ) field ( :last ) field ( :hair_color ) field ( :age ) field ( :cylon? ) end end There is also optional auto - generation of uuid attributes auto_generate_uuid : true do field ( :email ) field ( :first ) field ( :last ) field ( :hair_color ) field ( :age ) field ( :cylon? ) end Example Mnesia Store (default): defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person end Example ETS Store: defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , type : :ets end Add the Store to your application supervision tree: defmodule MyApp.Application do # code.. def start ( _type , _args ) do children = [ # other children MyApp.People.Store , # other children ] # code.. end end Now you have the default Store methods available!","ref":"readme.html#example-setup","title":"ActiveMemory - Example setup","type":"extras"},{"doc":"Store.all/0 Get all records stored Store.delete/1 Delete the record provided Store.delete_all/0 Delete all records stored Store.one/1 Get one record matching either an attributes search or match query Store.select/1 Get all records matching either an attributes search or match query Store.withdraw/1 Get one record matching either an attributes search or match query, delete the record and return it Store.write/1 Write a record into the memmory table","ref":"readme.html#store-api","title":"ActiveMemory - Store API","type":"extras"},{"doc":"There are two different query types available to help make finding the records in your store easier. The Attribute query syntax Attribute matching allows you to provide a map of attributes to search by. Store . one ( %{ uuid : &quot;a users uuid&quot; } ) Store . select ( %{ department : &quot;accounting&quot; , admin? : false , active : true } ) The match query syntax Using the match macro you can structure a basic query. query = match ( :department == &quot;sales&quot; or :department == &quot;marketing&quot; and :start_date &gt; last_month ) Store . select ( query )","ref":"readme.html#query-interface","title":"ActiveMemory - Query interface","type":"extras"},{"doc":"When starting a Store there is an option to provide a valid seed file and have the Store auto load seeds contained in the file. defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , seed_file : Path . expand ( &quot;person_seeds.exs&quot; , __DIR__ ) end","ref":"readme.html#seeding","title":"ActiveMemory - Seeding","type":"extras"},{"doc":"All stores are GenServers and have init functions. While those are abstracted you can still specify methods to run during the init phase of the GenServer startup. Use the before_init keyword and add the methods as tuples with the arguments. defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , before_init : [ { :run_me , [ &quot;arg1&quot; , &quot;arg2&quot; , ... ] } , { :run_me_too , [ ] } ] end","ref":"readme.html#before-init","title":"ActiveMemory - Before init","type":"extras"},{"doc":"All stores are GenServers and thus have a state. The default state is an array as such: %{ started_at : &quot;date time when first started&quot; , table_name : MyApp.People.Store } This default state can be overwritten with a new state structure or values by supplying a method and arguments as a tuple to the keyword initial_state . defmodule MyApp.People.Store do use ActiveMemory.Store , table : MyApp.People.Person , initial_state : { :initial_state_method , [ &quot;arg1&quot; , &quot;arg2&quot; , ... ] } end","ref":"readme.html#initial-state","title":"ActiveMemory - Initial State","type":"extras"},{"doc":"The package can be installed by adding active_memory to your list of dependencies in mix.exs : def deps do [ { :active_memory , &quot;~&gt; 0.2.1&quot; } ] end Check out the ( documentation )","ref":"readme.html#installation","title":"ActiveMemory - Installation","type":"extras"},{"doc":"There are many reasons to be leveraging the power of in memory store and the awesome tools of Mnesia and ETS in your Elixir applications. Storing config settings and Application secrets Instead of having hard coded secrets and application settings crowding your config files store them in an in memory table. Provide your application a small UI to support the secrets and settings and you can update while the application is running in a matter of seconds. One Time Use Tokens Perfect for short lived tokens such as password reset tokens, 2FA tokens, magic links (password less login) etc. Store the tokens along with any other needed data into an ActiveMemory.Store to reduce the burden of your database and provide your users a better experience with faster responses. API Keys for clients For applications which have a fixed set of API Keys or a relativly small set of API keys (less than a few thousand). Store the keys along with any relevent information into an ActiveMemory.Store to reduce the burden of your database and provide your users a better experience with faster responses. JWT Encryption Keys Applications using JWT's can store the keys in an ActiveMemory.Store and provide fast access for encrypting JWT's and fast access for publishing the public keys on an endpoint for token verification by consuming clients. Admin User Management Create an ActiveMemory.Store to manage your admins easily and safely. and many many many more...","ref":"readme.html#potential-use-cases","title":"ActiveMemory - Potential Use Cases","type":"extras"},{"doc":"Allow pass through :ets and mnesia options for table creation Allow pass through :ets and mnesia syntax for searches Mnesia co-ordination with Docker instance for backup and disk persistance Enhance match query syntax Select option for certain fields Group results Any suggestions appreciated.","ref":"readme.html#planned-enhancements","title":"ActiveMemory - Planned Enhancements","type":"extras"}]